/* Copyright (C) 2014 InfiniDB, Inc.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; version 2 of
   the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301, USA. */

#ifndef IDB_SYSINFO_H_
#define IDB_SYSINFO_H_

// System info stuff
struct sysinfo
{
  long uptime;                                  /* Seconds since boot */
  unsigned long loads[3];                       /* 1, 5, and 15 minute load averages */
  unsigned long totalram;                       /* Total usable main memory size */
  unsigned long freeram;                        /* Available memory size */
  unsigned long sharedram;                      /* Amount of shared memory */
  unsigned long bufferram;                      /* Memory used by buffers */
  unsigned long totalswap;                      /* Total swap space size */
  unsigned long freeswap;                       /* swap space still available */
  unsigned short procs;                         /* Number of current processes */
  unsigned long totalhigh;                      /* Total high memory size */
  unsigned long freehigh;                       /* Available high memory size */
  unsigned int mem_unit;                        /* Memory unit size in bytes */
  char _f[20 - 2 * sizeof(long) - sizeof(int)]; /* Padding to 64 bytes */
};
extern int sysinfo(sysinfo*);

#endif  // IDB_SYSINFO_H_
